GS="TAIR10_GFF3_genes_transposons.gff"
import plot_occupancy

print "Reading gene locations..."
ftrs={}
ftrs["genes"]=plot_occupancy.read_genes(f=GS)
ftrs["transposons"]=plot_occupancy.read_features(feature="transposable_element_gene",f=GS)

cetr={}
cetr["chr1"]=(15086046+15087045)/2
cetr["chr2"]=(3607930+3608929)/2
cetr["chr3"]=(13799418+13800417)/2
cetr["chr4"]=(3956022+395702)/2
cetr["chr5"]=(11725025+11726024)/2

def read_ids(f):
    res=[]
    for ln in open(f):
	res.append(ln.strip())
    return res

def flat((pos,val)):
    if pos>3245000 and pos<3505000:
        return pos,-0.05
    else:
        return pos,val


if __name__=="__main__":
    import sys,pylab
    resol=int(sys.argv[2])
    cmap=sys.argv[3]
    if sys.argv[4]=="0":
	interp="none"
    else:
	interp=None
	
    chrom=sys.argv[5]
    width=int(sys.argv[6])
    print sys.argv
    try:
	if sys.argv[1]=="sgr":
	    print "reading SGR signal..."
	    sgr=plot_occupancy.read_sgr(sys.argv[-1])
	    sgr["chr2"]=map(flat,sgr["chr2"])
	    print "plotting..."
	    plot_occupancy.signal_map(sgr,chrom,res=resol,width=width,cmap=cmap,inter=interp,cent=cetr)
	else:
	    if sys.argv[1]=="genes":
		gs=ftrs["genes"]
	    elif sys.argv[1]=="transposons":
		gs=ftrs["transposons"]
	    plot_occupancy.density_map(gs,chrom,normed=False,res=resol,width=width,cmap=cmap,inter=interp,cent=cetr)
	pylab.colorbar()
	pylab.show()
    except KeyError:
	print "BLAD! Wywolaj: heatmap  genes/transposons/sgr resolution colormap interpolation chromosome width plik.sgr"
