GS="TAIR10_GFF3_genes_transposons.gff"
import plot_occupancy

print "Reading gene locations..."
ftrs={}
ftrs["genes"]=plot_occupancy.read_genes(f=GS)
ftrs["transposons"]=plot_occupancy.read_features(feature="transposable_element_gene",f=GS)

def read_ids(f):
    res=[]
    for ln in open(f):
	res.append(ln.strip())
    return res
def join(ll):
    res=[]
    for x in ll:
	res+=x
    return res

if __name__=="__main__":
    import sys,pylab,numpy
    try:
	gs=ftrs[sys.argv[1]]
	print "reading SGR signals..."
	sgr=plot_occupancy.read_sgr(sys.argv[2])
	xmin,binum=float(sys.argv[3]),int(sys.argv[4])
	fs=sys.argv[5:]
	print "reading gene ids..."
	ids=[read_ids(f) for f in fs]
	print "plotting..."
	xss=[]
	od=plot_occupancy.occu_dict(gs,sgr)[0]
	for id_l,f in zip(ids,fs):
	    xs=[od[g] for g in id_l if g in od]
	    xss.append(xs)
	    bins=(numpy.arange(binum*1.)-(binum/2))/(binum/2)*xmin
	    pylab.hist(xs,bins,label=f,alpha=.5,normed=True)
	import scipy.stats
	print "Standard deviations",[scipy.std(x) for x in xss]
	print "Levene(Brown-Forsythe) test p-value",scipy.stats.levene(*xss)[1]

	means=[scipy.mean(x) for x in xss]
	print "mean values",means

	m=scipy.mean(means)
	print "T-test",
	for i,x in enumerate(xss):
	    print scipy.stats.ttest_ind(x,join(xss[:i]+xss[i+1:]))[1], #[scipy.stats.ttest_1samp(x,m)[1] for x in xss]
	print
	pylab.legend()
	pylab.show()
	
    except ValueError:
	print "BLAD! Wywolaj: histogram.py genes/transposons file.sgr y_min y_max ids1 ids2 ... idsN"
