GS="TAIR10_GFF3_genes_transposons.gff"
import plot_occupancy

print "Reading gene locations..."
ftrs={}
ftrs["genes"]=plot_occupancy.read_genes(f=GS)
ftrs["transposons"]=plot_occupancy.read_features(feature="transposable_element_gene",f=GS)
ftrs["ncrna"]=plot_occupancy.read_features(feature="ncRNA",f=GS)

def read_ids(f):
    res=[]
    for ln in open(f):
	res.append(ln.strip())
    return res


if __name__=="__main__":
    import sys,pylab,scipy,scipy.stats
    try:
	gs=ftrs[sys.argv[1]]

	print "reading SGR signals..."
	sgrs=sys.argv[2:4]
	sgrs=[plot_occupancy.read_sgr(f) for f in sgrs]
	exp_s=sgrs[0]
	exp_a=sgrs[1]
	exp={"+":exp_s,"-":exp_a}
	exp_dict=plot_occupancy.expr_dict(gs,exp)[0]
	#ymin,ymax=float(sys.argv[4]),float(sys.argv[5])
	fs=sys.argv[4:]
	print "reading gene ids..."
	ids=[read_ids(f) for f in fs]
	vals=[]
	for idl in ids:
	    vals.append([exp_dict[x] for x in idl if x in exp_dict])
	print fs,map(len,ids),map(len,vals)
	print "medians:",map(scipy.median,vals)
	print "means:",map(scipy.mean,vals)
	print "std. deviations:",map(scipy.std,vals)
	print "t-test p-values:"
	for i,v in enumerate(vals):
	    for j,w in enumerate(vals):
		if i<=j:
		    print fs[i],"vs",fs[j],scipy.stats.ttest_ind(v,w)[1]
	
	print "plotting..."
	
	pylab.boxplot(vals)
	pylab.xticks(range(1,len(fs)+1),fs)
	pylab.show()
    except KeyError:
	print "BLAD! Wywolaj: plot-expression.py  genes/transposons/ncrna file.S.sgr file.A.sgr  ids1 ids2 ... idsN"
